/*
** $Log:   C:/shell/vcs/abspath.c_v  $
**
**   Rev 3.6   02 Oct 1986 13:09:28   kent
**lint pass over everything
**
**   Rev 3.5   01 Oct 1986 13:23:10   kent
**Put all globals into shell.h
**
**   Rev 3.4   01 Oct 1986  9:24:04   kent
**Initial revision.
*/
#include "shell.h"
#ifndef NULL
#define NULL ((void *)0)
#endif

static char *massage(buf)
char *buf;
{
	register char *bp = buf;
	if (!no_map_backslashes)
		while (*bp)
		{
			*bp = (*bp == '\\') ? '/' : tolower(*bp);
			bp++;
		}
	else
		while (*bp)
		{
			*bp = (*bp == '/') ? '\\' : tolower(*bp);
			bp++;
		}				
	return buf;
}

char *abspath(relpath)
char *relpath;
{
	static char absolute[65];
	struct registers regs;
#ifdef AZTEC86
	extern unsigned _dsval;
#endif
	char current_slash = (no_map_backslashes ? '\\' : '/');
	char *strchr();
	/* handle drive part */
	if (relpath[1] == ':')
	{
		/* drive is part of the relative path */
		strncpy(absolute,relpath,2);
		absolute[0] = tolower(absolute[0]);	/* lowercase drive letter */
		absolute[2] = '\0';
		relpath += 2;	/* worry about rest of the path */
	}
	else
	{
		absolute[0] = bdos(0x19,0,0) + 'a';
		absolute[1] = ':';
		absolute[2] = '\0';
	}
	if ('\0' == *relpath || NULL == strchr("\\/",*relpath))	
	/* if first char is not a slash, it is a relative path */
	{
		absolute[2] = current_slash;
		absolute[3] = '\0';	/* terminate string */
		regs.ax = 0x4700;	/* get current directory */
#ifndef LARGEDATA
#ifdef AZTEC86
		regs.ds	= _dsval;
#endif
#ifdef MSC
		GETSEGS(&regs);
#endif
		/* put path in absolute past drive & slash */
		regs.si = (unsigned)absolute+3;
#else
		regs.ds = (unsigned)((unsigned long)absolute >> 16); /* segment */
		regs.si = (unsigned)absolute+3;
#endif
		regs.dx = absolute[0] - 'a' + 1;
#ifdef AZTEC86
		if (0 != (sysint21(&regs,&regs) & 1))	/* an error */
#endif
#ifdef MSC
		sysint21(&regs,&regs);
		if (regs.cflag)
#endif
			return NULL;
		(void)massage(absolute);		/* lower case and forward slash it */
		if ('\0' == *relpath) /* no path past drive */
			return absolute;
		if (0 == strncmp(relpath,"..",2))	/* parent directory */
		{
			int i;
			if (absolute[2] == current_slash &&
				absolute[3] == '\0') /* in root ? */
				return NULL;				/* no dot dot for root */
			/* strip off trailing path component */
			for (i = strlen(absolute)-1 ; i != 0 && 
				absolute[i] != current_slash ; i--)
				absolute[i] = '\0';
			relpath += 2;	/* skip .. */
		}
		else if ('.' == *relpath)	/* in current directory */
			++relpath;				/* skip it */
		if ('\0' == *relpath)		/* no more path ? */
			return absolute;
		/* if rest of relpath starts with a slash, bump past it */
		if (NULL != strchr("\\/",*relpath))
			++relpath;
		/* make sure absolute has a trailing backslash */
		if (absolute[strlen(absolute)-1] != current_slash)
			strcat(absolute,no_map_backslashes ? "\\" : "/");
		/* copy rest of relpath into absolute */
		strcat(absolute,relpath);
		return massage(absolute);
	}
	/* an absolute path */
	strcat(absolute,relpath);
	return massage(absolute);
}
