/*
** $Log:   C:/shell/vcs/cmds.c_v  $
**
**   Rev 3.6   02 Oct 1986 13:10:36   kent
**lint pass over everything
**
**   Rev 3.5   01 Oct 1986 13:25:26   kent
**Put all globals into shell.h
**
**   Rev 3.4   01 Oct 1986  9:22:40   kent
**Initial revision.
*/
#include "shell.h"

int my_exit()
{
	extern jmp_buf *exitenv;	/* this guy will get you to where we can fool
							** the command interpreter into thinking that
							** it has reached eof on input
							*/
	void set_switch();
	set_switch(oldswitch);
	longjmp(*exitenv,-1);	/* jump back into cli() */
}

int ver()
{
	extern char *version;
#ifdef AZTEC86
	unsigned dos_version = dos(0x30);
	fprintf(stderr,"%s DOS Version %d.%d\n",version,
		dos_version & 0xf, dos_version >> 8);
#endif
#ifdef MSC
	extern unsigned char _osmajor,_osminor;
	fprintf(stderr,"%s DOS Version %d.%d\n",version,
		_osmajor,_osminor);
#endif
	return 0;
}



int cmds()
{
	char *current;
	register int i,j,col;
	col = 1;
	for (i = 0; i < numcmds; i++)
	{
		current = commands[i].cmdname;
		write(1,current,j = strlen(current));
		for (;j < 16;j++)
			write(1," ",1);
		if (col == 4)
		{
			col = 1;
			crlf();
		}
		else
			++col;
	}
	crlf();
	return 0;
}

int findcmd(cmdbuf)
	char *cmdbuf;
{
	register unsigned low,high,mid;
	static char localbuf[256];
	int cond; char c;
	strcpy(localbuf,cmdbuf);
	cmdbuf = str_lower(localbuf);
	low = 0;
	high = numcmds - 1;
	while (low <= high)
	{
		mid = (low+high) / 2;
		if	( ( cond =  strcmp( cmdbuf, commands[mid].cmdname ) ) < 0 )
				high = mid - 1;
		else if (cond > 0)
				low = mid + 1;
		else
		{
			if ( ' ' == (c = cmdbuf[strlen(commands[mid].cmdname)]) ||
			     '\0' == c)
			{
				/* kludge to allow for program invocations like d:command */
				if (cmdbuf[1] == ':')
					if (cmdbuf[2] == '\0')
						return (int)mid;
					else
						return -1;
				return (int)mid;
			}
			return -1;
		}
	}
	return -1;
}

int hist(argc,argv)
	int argc;
	char **argv;
{
	register int i;
	register int size;

	if (argc==1)
	{
		if (_current->j < _current->histsize)
			i = 0;
		else
			i = (int)_current->j - (int)_current->histsize + 1;
		for (;i <= _current->j; i++)
		{
			char *s = _current->history[i % _current->histsize];
			printf("%d : ",i);
			write(1,s,strlen(s));
			crlf();
		}
		return 0;
	}
	if (argc==2)
	{
		size = atoi(argv[1]);
		if (size == 0)
			return -1;
		for (i = 0; i < _current->histsize; i++)
			if (_current->history[i])
				Free(_current->history[i]);
		Free((char *)_current->history);
		_current->history = (char **)MustMalloc(size * sizeof(char *));
		_current->histsize = size;
		_current->hiscount = 0;
		_current->j = 0;
		return 0;
	}
	return -1;
}

int last()
{
	printf("return code of last command %d\n",result);
	return result;
}
