/*
** $Log:   C:/shell/vcs/forkp.c_v  $
**
**   Rev 3.5   01 Oct 1986 13:27:04   kent
**Put all globals into shell.h
**
**   Rev 3.4   01 Oct 1986  9:23:12   kent
**Initial revision.
*/
#include "shell.h"
#ifdef MSC
#include <process.h>
#endif
#ifndef NULL
#define NULL ((void *)0)
#endif

int forkp(cmdline)
char *cmdline;
{
	register char *cp, *xp;
	int result;
	static char path[64];
	if (no_map_backslashes)
	{
		/* map arg0 forward slashes to backslashes */
		char *cp = cmdline;
		while (*cp && !isspace(*cp))
		{
			*cp = (*cp == '/')?'\\':*cp;
			cp++;
		}
	}
	if (666 != (result = tryfork("", cmdline)))
		return result;
	/* make sure you use the local environment,i.e. the one you see with
	   get_env, which is my function, instead of getenv
	 */
	if ((cp = get_env("PATH")) != 0) 
	{
		while (*cp) 
		{
			xp = path;
			while (*cp) 
			{
				if (*cp == ';') 
				{
					++cp;
					break;
				}
				*xp++ = *cp++;
			}
			*xp = 0;
			if (path[0] != 0)
				if (666 != (result = tryfork(path, cmdline)))
					return result;
		}
	}
	return 666;
}

static
int tryfork(dir, cmdline)
char *dir, *cmdline;
{
	char newname[64];
	register char *cp;
#ifdef AZTEC86
	int wait();
#define WAITVAL wait()
#endif
#ifdef MSC
#define WAITVAL _wait
#endif
	int _wait;
	extern int no_map_backslashes;
	char *strrchr(),*strchr();
	long vecsave,ctl_brk_setup();
	char *name = ntharg(cmdline,(unsigned)0);
	char *extension;
	strcpy(newname, dir);
	if (((cp = strchr(newname, '/')) || (cp = strchr(newname, '\\')))
				&& *(cp+1) != '\0')
		strcat(newname, no_map_backslashes ? "\\" : "/");
strcat(newname, name);
	if ((extension = strchr(name,'.')) == NULL)
	{
		strcat(newname,".com");
	}
	else
	{
		++extension;
		if (strcmp(extension,"com") != 0 && strcmp(extension,"exe") != 0
			&& strcmp(extension,"COM") != 0 && strcmp(extension,"EXE") != 0)
				return 666;
	}
	vecsave = ctl_brk_setup();
	if (666 != (_wait = fork(newname, cmdline)))
	{
		ctl_brk_restore(vecsave);
		return WAITVAL;
	}
	strcpy(strrchr(newname,'.'), ".exe");
	if (666 != (_wait = fork(newname, cmdline)))
	{
		ctl_brk_restore(vecsave);
		return WAITVAL;
	}
	ctl_brk_restore(vecsave);
	return 666;
}

int fork(path, cmdline)
char *path, *cmdline;
{
	static char cmdbuf[131];
        char *f1 = NULL,*f2 = NULL;
	char fcb1[16], fcb2[16];
	fcbinit(".", fcb1);		/* initialize fcb's, in case no args */
	fcbinit(".", fcb2);
	/* skip the zeroeth arg on the command line */
	while(*cmdline && isspace(*cmdline))	/* skip blanks if any */
		++cmdline;
	while(*cmdline && !isspace(*cmdline))	/* skip non-blanks */
		++cmdline;
	for(f1 = cmdline;*f1 && isspace(*f1);)	/* find first non blank for f1 */
		++f1;
	for(f2 = f1;*f2 && !isspace(*f2);)		/* find first blank for f2 */
		++f2;
	while (*f2 && isspace(*f2))				/* find first non blank for f2 */
		++f2;
	/* f1 and f2 will be NULL if there is no argv[1] and argv[2] respectively */
	if (*f1)	
		fcbinit(f1,fcb1);
	if (*f2)
		fcbinit(f2,fcb2);
	/* make sure the command line is terminated by a carriage return */
	strncpy(&cmdbuf[1],cmdline,127);
	if (strlen(cmdline) >= 127)
		cmdbuf[128] = '\0';
	cmdbuf[0] = strlen(&cmdbuf[1]);
	strcat(&cmdbuf[1],"\r");
	return fexec(path, env_paragraph, cmdbuf, fcb1, fcb2);
}

#ifdef MSC
fcbinit(name,fcb)
char *name; char fcb[16];
{
	struct registers regs;
	GETSEGS(&regs);
	regs.ax = 0x2900;
	regs.si = (unsigned)name;
	regs.di = (unsigned)fcb;
	regs.es = regs.ds;
	sysint21(&regs,&regs);
}

fexec(path,env_paragraph, cmdbuf, fcb1, fcb2)
char *path; unsigned env_paragraph; char *cmdbuf; char fcb1[16],fcb2[16];
{
	struct registers regs;
	static struct {
		unsigned env;
		char far *cmdline;
		char far *fcb1;
		char far *fcb2;
	} exec_packet;
	/* set up exec packet */
	exec_packet.env = env_paragraph;
	exec_packet.cmdline = (char far *)cmdbuf;
	exec_packet.fcb1 = (char far *)fcb1;
	exec_packet.fcb2 = (char far *)fcb2;
	GETSEGS(&regs);
	regs.ax = 0x4B00;
	regs.dx = (unsigned)path;
	regs.bx = (unsigned)&exec_packet;
	regs.es = regs.ds;
	sysint21(&regs,&regs);
	if (regs.cflag)
		return 666;
	return bdos(0x4d,0,0);
}
/*
long ctl_brk_setup() {}
ctl_brk_restore() {}
*/
#endif
