/*
** $Log:   C:/shell/vcs/more.c_v  $
**
**   Rev 3.5   01 Oct 1986 13:28:18   kent
**Put all globals into shell.h
**
**   Rev 3.4   01 Oct 1986  9:22:56   kent
**Initial revision.
*/
#ifndef MAIN
#include "shell.h"
#else
#include <stdio.h>
#include <ctype.h>
#include <setjmp.h>
#include <signal.h>
#include <fcntl.h>
extern int (*signal())();
crlf()
{
	write(2,"\r\n",2);
}
#endif

static int (*moresig)();

extern FILE *fdopen();

/*lint +fvr */
extern int display();
/*lint -fvr */

static long int size, position;
static char filename[30];
static char isaconsole = '\0';
static char isapipe = '\0';
static int tabsize = 8;
#define STDIN 0
#define STDOUT 1
#define STDERR 2
#define ESC '\033'

void std_out(c)
{
	write(1,&c,1);
}

static void (*output)();


jmp_buf moreenv;

void
moreintr()
{	/* ignore signals until we finish putting stuff back in order */
	(void)signal(SIGINT,SIG_IGN);	
	longjmp(moreenv,-1);
}
/*lint +fva */
#ifdef MAIN
#ifdef AZTEC86
static void x(c)
{
	if (c=='\n')
		x('\r');
	write(1,&c,1);
}

void printf(fmt,args)
	char *fmt; unsigned args;
{
	format(x,fmt,&args);
}
#endif
int main
#else
int more
#endif
(argc,argv)
	int argc;
	char *argv[];
{
	FILE *fp = NULL, *fopen();
	long ftell();
	long int fsize();
	int input = -1;
	if (-1 == setjmp(moreenv))
	{
		write(2,"Interrupted\r\n",13);
		/*lint -e530 */ if (fp!=NULL) fclose(fp); /*lint +e530 */
		(void)signal(SIGINT,moresig);
		return -1;
	}

	moresig = signal(SIGINT,moreintr);
	isaconsole = isatty(STDOUT);
	isapipe = !isatty(STDIN);
	output = std_out;
	if ( (*(++argv))[0] == '-' && isdigit((*argv)[1]) )
	{
		tabsize = atoi( (*argv+1) );
		--argc;
	} else
	{
		--argv;
	}
	if (argc == 1)
	{
		input = dup(0);	/* copy the redirected file */
		if (NULL == (fp = fdopen(input,FTOREAD)))
		{
			return -1;
		}
		close(0);	/* get rid of redirection */
		if (0 != open("CON",O_RDONLY))
		{
			fprintf(stderr,"problems reopening standard input!!!\n");
		}
		else
			display(fp);
		fclose(fp);
		crlf();
		return 0;
	}
	while(--argc) 
	{
		if (NULL == (fp = fopen(*(++argv),FTOREAD)) )
		{
			fprintf(stderr,"more - can't open %s\n",*argv);
			continue;
		}
		strncpy(filename,*argv,30);
		if (filename[29])
			filename[29] = '\0';
		if (!isapipe)
			size = fsize(fp);
		position = 0;
		if (-2 == display(fp))
			argc = 1;		/* force completion of command */
		(void)fclose(fp);
	}
#ifdef IBMPC
	if (isaconsole)
		scr_echo(1);
#endif
	crlf();
	tabsize = 8;
	isaconsole = isapipe = '\0';
	signal(SIGINT,moresig);
	return 0;
}

long fsize(fp) 
	FILE *fp;
{
	extern long ftell(); int fseek();
	long position, last;
	position = ftell(fp);
	if (-1L == fseek(fp,0L,2))
	{
		fprintf(stderr,"more - error on fseek\n");
	}
	last = (ftell(fp));
	fseek(fp,position,0);
	return last;
}
#define LBUFSIZE (unsigned)160
char linebuffer[LBUFSIZE];
int lines;

int display(fp)
	FILE *fp;
{
	char *fgets();
	long ftell();
	lines = 1;
	while ( NULL != fgets(linebuffer,LBUFSIZE,fp))
	{
		if (isaconsole)
		{
			if (lines == 1)		/* top of display */
			{
				/* ansi terminal screen clear */
				static char *clrstr = "\033[2J";
				write(1,clrstr,strlen(clrstr));
			}
		}
		lines += localputs(linebuffer);
		if (isaconsole)
		{
			if (lines >=  24)		/* bottome of display */
			{
				position = ftell(fp);
				/* ansi terminal positioning */
				write(1,"\033[25;1H\033[7m",11);
				if (!isapipe)
					printf(
"%s - %10ld bytes - %d%% displayed - <ESC> = skip to next file\033[m",
					filename,size,percent(position,size) );
				else
					printf("-more-\033[m");
				switch(bdos(0x7,0,0))
				{
				case ESC :
					printf("\033[m");
					fflush(stderr);
					return 0;
#ifdef IBMPC
				case -2 :
#else
				case 3 :
#endif
					return -2;
				default:
					break;
				}

				lines = 1;
			}
		}
	}
	if (isaconsole)
	{
		if (lines != 1)		/* bottome of display */
		{
			/* ansi terminal positioning */
			write(1,"\033[25;1H\033[7m",11);
			if (!isapipe)
			{
				position = ftell(fp);
				printf(
			"%s - %10ld characters - %d%% displayed\033[m",
			filename,size,percent(position,size) );
			}
			else
				printf("-done-\033[m");
			bdos(0x7,0,0);
			fflush(stderr);
			lines = 1;
		}
	}
}

int percent(x,y)
	long int x,y;
{	/* returns integer percentage of x into y */
	x *= 100;
	if (y)
		x /= y;
	else
		x = 100;
	return ((int)x);
}

int localputs(lb)
	register char *lb;
{
	int lines, pos, tabstop;
	lines = 1;
	pos = 0;
	while (*lb)
	{
		switch (*lb)
		{
		case '\t':
			tabstop = pos + (tabsize - (pos % tabsize));	
			for (;pos <= tabstop; pos++)
				(*output)(' ');
			break;
		case '\n':
			(*output)('\r');
		default:
			(*output)(*lb);
			pos++;
		}
		if (pos == 79)
		{
			pos = 1;
			(*output)('\r');
			(*output)('\n');
			++lines;
		} else if (pos > 79)
		{
			pos -= 80;
			++lines;
		}
		++lb;
	}
	return lines;
}
