/*
** $Log:   C:/shell/vcs/_croot.c_v  $
**
**   Rev 3.5   01 Oct 1986 13:32:08   kent
**Put all globals into shell.h
**
**   Rev 3.4   01 Oct 1986  9:24:32   kent
**Initial revision.
*/
/* Copyright (C) 1981,1982, 1983 by Manx Software Systems */
#include "shell.h"

void _abort();
/* noexpand can be set by routines before calling _Croot */
int noexpand = 0;

#define ARGMAX 256 
static char *Argv[ARGMAX];
static int Argc;

int _Croot(cp,cmd)
register char *cp;
int (*cmd)();
{
	int returnval = 0;
	register char *cp2;
	char *strchr(),*strrchr();
	char curr_quote;
	/* loop through arguments */
	for (Argc = 0;;) 
	{
		/* skip blanks */
		while (*cp == ' ' || *cp == '\t')
			++cp;

		/* if you're at the end of command line, you're done */
		if (*cp == '\0')
			break;
		if (NULL != strchr("\"'",*cp))
		{
		/* if you hit a quote, next arg starts after _matching close quote */
			curr_quote = *(cp2 = cp);
			while(*++cp2)
			{
				if (*cp2 == curr_quote)
				{
					*cp2++ = '\0';
					break;
				}
			}
			++cp;	/* move cp past quote */
		}
		else
		{
			/* find beginning of next argument */
			cp2 = cp;	/* save original pointer to the string */
			while (*++cp2)
			{
				/* if you hit a space char - stick a null in to terminate last
				   argument
				 */
				if (*cp2 == ' ' || *cp2 == '\t') 
				{
					*cp2++ = 0;
					break;
				}
			}
		}
		/* update the next argv pointer */
		Argv[Argc] = cp;
#ifdef DEBUG
			fprintf(stderr,"%s$\n",cp);
#endif
		/* bump the argument count */
		if (++Argc == ARGMAX)
			_abort();
		cp = cp2;	/* point to beginning of next argument */
	}
	Argv[Argc] = NULL;	
	returnval=(*cmd)(Argc,Argv);
	return returnval;
}
/*lint -e214 -e29 */
void _abort()
{
	write(2, "Too many args.", 14);
	_exit(200);
}
/*lint +e214 +e29*/
